/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	STK504LCD𐧌䂷邽߂Ɏgp֐
 *
 * \par Application note:
 *	AVR063: STK504pLCDײ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɊւĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation	: http://www.atmel.com \n
 *	xEҰ			: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: stk504_lcd.c,v $
 * $Date: 2006/02/16 18:04:59 $  \n
 *****************************************************************************/

// ݸٰ ̧
#include "stk504_lcd.h"		// ^錾AĒ`A__flashQƕ\܂݂܂B
#include "defines.h"		// ʓIȒ`܂݂܂B
#include <iom3290.h>		// ޲L`܂݂܂B
#include <inavr.h>			// gp\ȌŗL֐AႦ__delay_cycles();܂݂܂B

volatile union _LCD_status LCD_status = {0x01};		//!< LCD_status={0,0,0,0,0,0,FALSE,TRUE};
unsigned char LCD_timer = LCD_TIMER_SEED;
unsigned char LCD_displayData[LCD_REGISTER_COUNT];	//!< LCD\ޯ̧(2dɏ՗p)

//! 14ĕpQƕ\
__flash unsigned int LCD_character_table[] =
{
  0x0000,	// '*' (?)
  0x0000,	// '+'
  0x0000,	// ',' (`)
  0x0000,	// '-'
  0x0000,	// '.' (`)
  0x0000,	// '/' (`)
  0x93C5,	// '0'
  0x80C0,	// '1'
  0x1994,	// '2'
  0x9894,	// '3'
  0x8891,	// '4'
  0x9815,	// '5'
  0x9915,	// '6'
  0x8084,	// '7'
  0x9995,	// '8'
  0x9895,	// '9'
  0x0000,	// ':' (`)
  0x0000,	// ';' (`)
  0x0000,	// '<' (`)
  0x0000,	// '=' (`)
  0x0000,	// '>' (`)
  0x0000,	// '?' (`)
  0x0000,	// '@' (`)
  0x8995,	// 'A' (+ 'a')
  0xB8A4,	// 'B' (+ 'b')
  0x1105,	// 'C' (+ 'c')
  0xB0A4,	// 'D' (+ 'd')
  0x1915,	// 'E' (+ 'e')
  0x0915,	// 'F' (+ 'f')
  0x9905,	// 'G' (+ 'g')
  0x8991,	// 'H' (+ 'h')
  0x2020,	// 'I' (+ 'i')
  0x9180,	// 'J' (+ 'j')
  0x0551,	// 'K' (+ 'k')
  0x1101,	// 'L' (+ 'l')
  0x81C3,	// 'M' (+ 'm')
  0x8583,	// 'N' (+ 'n')
  0x9185,	// 'O' (+ 'o')
  0x0995,	// 'P' (+ 'p')
  0x9585,	// 'Q' (+ 'q')
  0x0D95,	// 'R' (+ 'r')
  0x1406,	// 'S' (+ 's')
  0x2024,	// 'T' (+ 't')
  0x9181,	// 'U' (+ 'u')
  0x0341,	// 'V' (+ 'v')
  0x8781,	// 'W' (+ 'w')
  0x0642,	// 'X' (+ 'x')
  0x2042,	// 'Y' (+ 'y')
  0x1244,	// 'Z' (+ 'z')
  0x0000,	// '[' (`)
  0x0000,	// '\' (`)
  0x0000,	// ']' (`)
  0x0000,	// '^' (`)
  0x0000	// '_' (`)
};

//! 7ĕpQƕ\
__flash unsigned char LCD_digit_table[] =
{
  0xF0,		// '*' (xL)
  0x00,		// '+' (`)
  0x00,		// ',' (`)
  0x10,		// '-'
  0x00,		// '.' (`)
  0x00,		// '/' (`)
  0xEE,		// '0'
  0x44,		// '1'
  0xDA,		// '2'
  0xD6,		// '3'
  0x74,		// '4'
  0xB6,		// '5'
  0xBE,		// '6'
  0xC4,		// '7'
  0xFE,		// '8'
  0xF6,		// '9'
  0x00,		// ':' (`)
  0x00,		// ';' (`)
  0x00,		// '<' (`)
  0x00,		// '=' (`)
  0x00,		// '>' (`)
  0x00,		// '?' (`)
  0x00,		// '@' (`)
  0xFC,		// 'A'
  0x3E,		// 'B'
  0xAA,		// 'C'
  0x5E,		// 'D'
  0xBA,		// 'E'
  0xB8,		// 'F'
};	


/******************************************************************************
*
* ֐ : LCD_PutChar( unsigned char c, unsigned char digit )
*
******************************************************************************/
void LCD_PutChar( unsigned char c, unsigned char digit )
/*! \brief 14Č̕\
 *  \param c		\ׂ
 *  \param digit	ׂʒu(L͈͂1`7)
 */
{
  unsigned int seg, segMask;
  unsigned char i;
  unsigned char mask, nibble, nibbleMask;
  unsigned char *ptr;

  if ( digit == 0 || digit >=8)			// ͈͊OʒuŁA
  {
	return;
  }

  if ( (c >= '*') && (c <= 'z') )		// ͈͓ŁA
  {
	if ( c >= 'a' ) c &= ~0x20;			// ȂA啶֕ϊ
	c -= '*';							// Qƕ\ψʂɕϊ
	if ( c > 0x35 )						// Qƕ\OŁA
	{
	  return;
	}
	else								// Qƕ\ŁA
	{
	  seg = LCD_character_table[c];		// ΉޯĒl擾
	}
  }
  else									// ͈͊OŁA
  {
	return;
  }

  segMask = 0x4008;						// ĊO2ޯėpՕl擾

  i = digit-1;							// ʒu0ɕύX
  if ( i >= 8 )							// ͈͊OʒuŁA
	return;
  i >>= 1;								// ͈͓ʒuŁALCDDRޯ̧擪ψ(i={0,0,1,1,2,2})ɕύX
  ptr = LCD_displayData + i;			// LCDDRޯ̧Ή擪ʒuwq擾

  i = 4;								// 1ɑ΂LCDDRv평
  do									// 4LCDDRޯ̧XV
  {
	nibble = seg & 0x000F;				// ΉLCDDRpޯĒl̂ݒo
	nibbleMask = segMask & 0x000F;		// ΉLCDDRpՕl̂ݒo

	seg >>= 4;							// pޯĒlŉقֈړ
	segMask >>= 4;						// pՕlŉقֈړ

	if ( digit & 0x01 )					// ŁA
	{
	  mask = 0xF0 | nibbleMask;			// َՕl擾
	}
	else								// ŁA
	{
	  nibble <<= 4;						// ΉޯĒlقֈړ
	  mask = 0x0F | ( nibbleMask <<4 );	// َՕl擾
	}
	*ptr = (*ptr & mask) | nibble;		// Ή޲Ă̑ΉٍXV
	ptr += 5;							// ʒuwqis
  } while ( --i );						// 4LCDDR܂Ōp
}

/******************************************************************************
*
* ֐ : LCD_PutDigit( unsigned char c, unsigned char digit )
*
******************************************************************************/
void LCD_PutDigit( unsigned char c, unsigned char digit )
/*! \brief \7Č116il
 *			0'-''1'\łȂ̂œ܂B
 *			1`4'0'`'9''A'`'F'\ł܂B
 *			̓L\łALCD_digit_table[]B
 *  \param c		7Čɕ\ׂ(L͈͂'*'`'F')
 *  \param digit	gpʒu(L͈͂0`4)
 */
{
  unsigned char i, j, seg;
  unsigned char mask, lastnibblemask, lookupdata;
  unsigned char *ptr;

  if (digit == 0)						// 擪(-1)ŁA
  {
	LCD_SetSeg( G8, 0 );				// -1(-)OFF
	LCD_SetSeg( BC8, 0 );				// -1(1)OFF
	if ( c == '-' )						// '-'wŁA
	{
	  LCD_SetSeg( G8, 1 );				// -1(-)ON
	}
	else								// '-'wȊOŁA
	{
	  if ( c == '1' )					//  '1'wŁA
	  {
		LCD_SetSeg ( BC8, 1 );			// -1(1)ON
	  }
	}
	return;
  }

  if ( (c >= '*') && (c <= 'F') && (digit <= 4))	// L͈͊L͈͂ŁA
  {
	c -= '*';							// Qƕ\ψʂɕϊ
	lookupdata = LCD_digit_table[c];	// ΉޯĒl擾
  }
  else												// ܂͖ʒuŁA
  {
	return;
  }

  ptr = LCD_displayData + 19;			// LCDDRޯ̧Ή擪ʒuwq擾

  for (j=0; j<4 ;j++)					// 4LCDDRXV(LCDDR:19,14,9,4)
  {
	mask = 0xC0;						// LCDDR19,14,9pޯĎՕl擾
	lastnibblemask = 0x40;				// LCDDR4pޯĎՕl擾
	seg = ( lookupdata & mask );        // Ή2ޯĕ\ޯĒl擾((MSB)|A|B|F|G|E|C|D| |(LSB))

	for (i = digit-1; i>0; i--)
	{
	  seg >>= 2;						// (ŏIIɑΉ2ޯĂΉޯĈʒuֈړ)
	  mask >>= 2;						// (ŏIIɑΉՕl擾)
	  lastnibblemask >>= 2;				// (ŏIILCDDR4pیޯĒl擾)
	}
	if (j == 3)							// LCDDR4ŁA(ޯĂ̋LpȂ̂)
	{
	  mask = mask & ~lastnibblemask;	// Ή1ޯĈȊOpՕl␳
	}

	*ptr = (*ptr & ~mask) | seg;		// Ή޲Ă̑Ή2ޯčXV
	ptr -= 5;							// LCDDRޯ̧ʒuwq
	lookupdata <<= 2;					// p2ޯĂޯ7,6ֈړ
}

/******************************************************************************
*
* ֐ : LCD_AllSegments( unsigned char input )
*
******************************************************************************/
void LCD_AllSegments( unsigned char input )
/*! \brief \ޯ̧Ŝ1܂0ŏ[U
 *  \param input _lƂĎgp(0x00=OFF,0x00ȊO=ON)
 */
{
  unsigned char i;
  unsigned char *ptr;

  if( input )							// 1wŁA
	input = 0xFF;						// Sޯ=1l擾(0wȂAɑSޯ=0)
  ptr = LCD_displayData;				// LCDDRޯ̧擪ʒuwq擾
  i = 20;								// LCDDRv평
  do			  						// LCDDRޯ̧Sݒ(1)܂͉(0)
  {
	*ptr++ = input;						// LCDDRޯ̧Ή޲Ăݒ(1)܂͉(0)
  } while ( --i );						// SLCDDRޯ̧܂Ōp
}

/******************************************************************************
*
* ֐ : LCD_SetSeg(unsigned char symbol, unsigned char input)
*
******************************************************************************/
void LCD_SetSeg(unsigned char symbol, unsigned char input)
/*! \brief LCD\ޯ̧̾ĂON܂OFF
 *  \param symbol	stk504_lcd.ḩقł̾Ē`gp܂B
 *  \param input	_lƂĎgp(0x00=OFF,0x00ȊO=ON)
 */
{
  unsigned char offset;
  unsigned char setbit;
  unsigned char *ptr;

  // symbol`=bbbnnnnn(bޯĔԍ(0`7)AnLCDDRԍ(0`19))
  // Lsymbollstk504_lcd.hŒ`Ă܂B
  setbit = (symbol >> 5);				// ޯĔԍ擾
  offset = (symbol & 0x1F);				// LCDDRޯ̧ψ(ڼ޽ԍ)擾
  if ( offset >= 20 )					// LCDDR͈͊OŁA
  {
	return;
  }
  ptr = LCD_displayData + offset;		// ΉLCDDRޯ̧ʒuwq擾
  if ( input )							// ݒ(1)wŁA
  {
	*ptr = (*ptr) | ( 1 << setbit);		// ΉLCDDRޯ̧̑ΉޯĂݒ(1)
  }
  else									// (0)wŁA
  {
	*ptr = (*ptr) & ~( 1 << setbit);	// ΉLCDDRޯ̧̑ΉޯĂ(0)
  }
}


/******************************************************************************
*
* ֐ : LCD_BarSeg ( unsigned char value )
*
******************************************************************************/
void LCD_BarSeg ( unsigned char value )
/*! \brief \8_ް Ēl
 *  \param value ް Ăɕ\ׂޯĒl(LȔ͈͂0`$FF)
 */
{
  unsigned char mask, i, n, m;
  unsigned char *ptr;

  mask = 0x80;							// ޯĎՕl擾
  ptr = LCD_displayData + 18;			// LCDDRޯ̧Ήʒuwq擾(LCDDR:18,13,8,3)

  for(n=0; n<4 ; n++)					// 4LCDDRXV
  {
	i=0;								// ޯĒl
	for(m=0; m<2; m++)					// 2ޯĕ
	{
	  i |= ( value & mask );			// wΉޯĒl擾
	  i >>= 1;							// ޯĈʒu␳(ŏIIޯ6,5ʒu)
	  value <<= 1;						// pwޯĒlޯ7ʒuֈړ
	}
	*ptr = i | (*ptr & 0x9F);			// ΉLCDDRޯ̧2ޯčXV((MSB)| |Sn|Sn+1| | | | | |(LSB))
	ptr -= 5;							// ʒuwq
  }
}

/******************************************************************************
*
* ֐ : LCD_Update(void)
*
******************************************************************************/
void LCD_Update(void)
/*! \brief \ޯ̧eLCDDR0`19֕ʁBLCDDRڼ޽XV̂߂updateRequired
 *		   ׸ނݒ肵Ċ荞݂҂ɁAILCDDRڼ޽ւ̋XV
 *		   ܂B
 */
{
  unsigned char *src, *dest;
  unsigned char i;

  i = 20;								// LCDDRڼ޽擾
  dest = &pLCDREG;						// LCDDRڼ޽ʒuwq擾
  src = LCD_displayData;				// LCDDRޯ̧ʒuwq擾
  do									// ޯ̧eLCDDR֕
  {
	*dest++ = *src++;					// ΉLCDDRޯ̧lΉLCDDRɕ
  } while ( --i );						// LCDDRڼ޽p
}

/******************************************************************************
*
* ֐ : LCD_init(void)
*
******************************************************************************/
void LCD_init(void)
/*! \brief ATmega3290STK504\gpɏ
 */
{

  LCD_AllSegments( FALSE );					// LCDDRޯ̧(SOFF)
  PRR &= ~(1<<PRLCD);						// LCDd͍팸
  LCDCRA = (1<<LCDEN);						// LCD틖

  LCD_CONTRAST_LEVEL(LCD_INITIAL_CONTRAST);	// LCDZWِݒ

  // 񓯊ۯI,SCOM݋,S ݋
  LCDCRB = (1<<LCDCS) | (1<<LCDMUX1) | (1<<LCDMUX0) | (1<<LCDPM3)| (1<<LCDPM2) | (1<<LCDPM1)| (1<<LCDPM0);
  LCDFRR = (1<<LCDPS0);						// LCDOuCLK(lcd)/64=64Hzɐݒ

  LCDCRA |= (1<<LCDIE);						// LCDڰъJn荞݋

}

/******************************************************************************
*
* LCD荞ٰ
*
******************************************************************************/
#pragma vector = LCD_vect
__interrupt void LCD_vect_interrupt( void )
/*! \brief LCD\ޯ̧ׯƍXV׸ސݒ̂߂LCD荞ٰ
 */
{
  unsigned char i;
  unsigned char *src, *dest;

  LCD_timer--;								// XVԊuv팸
  if( LCD_timer == 0 )						// XVԊuo߂ŁA
  {
	if( LCD_status.updateRequired == TRUE )	// XVvLŁA
	{
//	  PINB = 0x40;

	  LCD_timer = LCD_TIMER_SEED;			// XVԊuvĐݒ
	  LCD_status.updateComplete = TRUE;		// XV׸ސݒ
	  LCD_status.updateRequired = FALSE;	// XVv׸މ

	  i = 20;								// LCDDRڼ޽擾
	  dest = &pLCDREG;						// LCDDRڼ޽ʒuwq擾
	  src = LCD_displayData;				// LCDDRޯ̧ʒuwq擾
	  do									// ޯ̧eLCDDR֕
	  {
		*dest++ = *src++;					// ΉLCDDRޯ̧lΉLCDDRɕ
	  } while ( --i );						// LCDDRڼ޽p
	}
	else									// XVvȂŁA
	{
	  LCD_timer = 1;						// XVvɑ΂ő̂߂ɍXVԊuv=1ݒ
	  LCD_status.updateComplete = FALSE;	// XV׸މ
	}
  }
}
